/*!
  EnqJS v0.9.9

*/

function enq(){
	var queued = []
	  , returned
	  , expected=0;

	// Generate the return function for taskObject. Each task needs a
	// specific function to bind the response to correct order of call
	function binder(taskID) {
		expected++;
		return function(ret) {
			expected--;
			if(!returned && taskID !== 'false') {
				if		(typeof taskID == 'number') returned=[];
				else if (typeof taskID == 'string') returned={};
			};
			taskID !== false ? returned[taskID]=ret : returned = ret;
			// Timeout needed to increment expected, if next item exists.
			// If it run without timeout, expected always be 0 and only
			// the first function of the group will be executed.
			setTimeout(function(){if (! expected) runQueue();},1);
		}
	}

	// This object is the "this" reference inner each task function.
	function taskObject(taskID){
		return {
			"return" :binder(taskID),
			"stop"   :function(){},
			"timeout":function(){}
		}
	}

	// If first item of args is an object, it returns the functions
	// contained there else return a list of functions in args
	function argumentFilter(args){
		var ret;
		if (typeof args[0] == 'object') {
			args=args[0];
			ret={};
			for (var i in args) if (args.hasOwnProperty(i) && typeof args[i] == 'function') {
				ret[i]=args[i];
			}
			return ret;
		}
		ret=[];
		for (var i=0,ii=args.length;i<ii;i++) if (typeof args[i] == 'function') {
			ret.push(args[i]);
		}
		return ret;
	}

	// Take the next group of tasks from the stack;
	function runQueue() {
		var lastReturned = returned instanceof Array ? returned : [returned]
		  , tasks = queued.shift();

		if (tasks) tasks = tasks.tasks;
		returned = undefined;

		if (tasks instanceof Array) {
			for (var t=0,tt=tasks.length; t<tt; t++) {
				tasks[t].apply(taskObject(t),lastReturned);
			};
			return;
		}
		if (typeof tasks == 'object') {
			for (var t in tasks) if (tasks.hasOwnProperty(t)) {
				tasks[t].apply(taskObject(t),lastReturned);
			}
			return;
		}
	}

	// Add a new group of tasks in stack.
	function enqueue(){
		var tasks = argumentFilter(arguments);
		queued.push({ tasks:tasks });
		// Timeout needed to increment expected, if next item exists.
		// If it run without timeout, expected always be 0 and the functions
		// will be executed immediately obtaining undefined as parameter.
		setTimeout(function(){if (! expected) runQueue();},1);
		return enqueue;
	}
	return enqueue.apply(null,arguments);
}

if (typeof window != 'object') exports.enq=enq;
